package
{
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import flashx.textLayout.formats.BackgroundColor;
	import flashx.textLayout.operations.RedoOperation;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
		private var game:Game;
		private var grp:FlxGroup;
		private var bg:FlxGroup;
		
		override public function create():void
		{
			bgColor = Game.bgcolor;
			game = Game.NewBoard();
			bg = new FlxGroup();
			add(bg);
			grp=new FlxGroup();
			bg.add(grp);
			DrawGame();
		}
		
		private function DrawGame():void
		{
			bg.remove(grp,true);
			grp = game.DrawBoard();
			bg.add(grp);
		}
		
		private function TryMove(player:int,dx:int,dy:int):void
		{
			if (game.CanMove(player,dx,dy))
			{				
				game = game.DoMove(player,dx,dy);
				
				if (player==1)
				{
					turn=2;
				}
				else
				{
					turn=1;
				}
				
				DrawGame();
				if (game.winner!=0)
				{
					var t:FlxText = new FlxText(0,0,FlxG.width,"THE WINNER IS " + game.winner);
					add(t);					
				}
			}
//			/trace("score " + game.rating);
		}
		
		private function TakeAIMove():void
		{
			var bestmove:int = game.BestAIMove(3);
			
			TryMove(2,Game.dirs[bestmove][0],Game.dirs[bestmove][1]);
		}
		
		public var turn:int=1;
		private static var aimode:Boolean=true;
		override public function update():void
		{
			//if (FlxG.keys.justPressed("Q"))
			//{
			//	aimode=!aimode;
			//}
			if (FlxG.keys.justPressed("R"))
			{
				FlxG.state = new GameState();
				return;
			}
			if (turn==1 && game.winner==0)
			{
				if (FlxG.keys.justPressed("UP"))
				{
					TryMove(1,0,-1);
				}
				if (FlxG.keys.justPressed("DOWN"))
				{
					TryMove(1,0,1);				
				}
				if (FlxG.keys.justPressed("LEFT"))
				{
					TryMove(1,-1,0);				
				}
				if (FlxG.keys.justPressed("RIGHT"))
				{
					TryMove(1,1,0);				
				}
			}
			else
			{
				
				if (aimode)
				{
					if (game.winner==0)
					{
						TakeAIMove();
					}
				}
				else
				{
					if (FlxG.keys.justPressed("W"))
					{
						TryMove(2,0,-1);
					}
					if (FlxG.keys.justPressed("S"))
					{
						TryMove(2,0,1);				
					}
					if (FlxG.keys.justPressed("A"))
					{
						TryMove(2,-1,0);				
					}
					if (FlxG.keys.justPressed("D"))
					{
						TryMove(2,1,0);				
					}
				}
			}
			super.update();
		}
	}
}